#ifndef POLYNOME_HPP
#define POLYNOME_HPP

#include <iostream>
#include <cassert>
#include <initializer_list>

using namespace std;

class Polynome{
private:
  size_t taille; //Taille du tableau coeffs
  double* coeffs;
public:
  //== Constructeurs ==//
  
  //! a) Crée le polynôme nul lors de l'appel de Polynome P
  Polynome();
  
  //! b) Crée le polynôme X^n lors de l'appel Polynome P(5)
  Polynome(size_t n);

  //! g) Crée un polynôme à partir d'une liste de coefficients
  Polynome(initializer_list<double> l);
  
  //! c) Destructeur de la classe
  ~Polynome();

  //! d) Retourne le degre
  int degre() const;

  //! e) Acces aux coefficients
  double& operator[](size_t i);
  double operator[](size_t i) const;

  //! f) Operator= qui permet P=Q
  Polynome& operator=(const Polynome& Q);
  
};

ostream& operator<<(ostream& os,const Polynome& P);
#endif
